<?php


function aui_title($title, $text="", $button="") {
    if (is_string($button)) {
        if (strlen($button) > 1) {
            $btn = true;
            $btnURL = $button;        }
    }
    else if (is_array($button)) {
        $btn = true;
        $btnURL = $button['url'];
        $btnTitle = $button['title'];
    }
    $html = '<h1 class="page_title">';
    if ($btn) { $html .= aui_backButton($btnURL, $btnTitle); }
    $html .=  $title .' <span>'. $text .'</span></h1>';
    return $html;
}

function aui_button($title, $url, $class="", $icon="") {
    if (! $class) $class = "primary";
    $html = '<a href="'.$url.'" class="btn btn-'.$class.' btn-icon-split">
                    <span class="icon text-white-75">
                      <i class="fas fa-'.$icon.'"></i>
                    </span>
                    <span class="text">'.$title.'</span>
                  </a>';
    return $html;
}

function aui_backButton($backURL, $title="") {
    $html = '<a href="'.$backURL.'" class="btn btn-secondary btn-icon-split mr-3">
            <span class="icon text-white-75"> <i class="fas fa-arrow-left"></i> </span>';
    if (strlen($title) > 0) {
        $html .= '<span class="text">'.$title.'</span>';
    }
    $html .= '</a>';
    return $html;
}

function aui_colorBox($content, $title="", $type="primary") {
    if (strlen($title) > 0) {
        $title = "<p class='h4'>".$title."</p>";
    }
    $html = '<div class="mb-2">
                <div class="card bg-'.$type.' text-white shadow">
                    <div class="card-body p-3">'.$title.$content.'</div>
                </div>
            </div>';
    return $html;
}

function aui_errorBox($content, $title="", $class="") {
    if (! $title) $title = "!!! HIBA !!!";
    return aui_colorBox($content, $title, "danger ".$class);
}

function aui_warningBox($content,  $title="", $class="")  {
    return aui_colorBox($content, $title, "warning ".$class);
}

function aui_successBox($content, $title="", $class="") {
    return aui_colorBox($content, $title, "success ".$class);
}



function aui_spinnerDiv($title="") {
    if (! $title) { $title = "Loading..."; }
    $html = '<div id="spinner_div">
                <div class="d-flex justify-content-center">
                    <button class="btn btn-primary" type="button" disabled>
                        <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>'
                        .$title.
                    '</button>
                </div>
            </div>';
    return $html;
}
?>