<?php

// ----------------------------------------------------------------------
// --------------- AZ EREDETI CIMLISTA ADATOK TBLJA -------------------
// ----------------------------------------------------------------------
class swProjectUsers extends Basic {
    var $className = "swProjectUsers";
    var $tbl_name_tmpl = "project_{ID}_users";
    var $set_tables = false;
    var $prID = 0;

    function __construct($dbConn) {
        parent::__construct($dbConn);
    }

    function getIDbyParams($UID, $SUID, $KKOD=0, $prID=0) {
        if (! $prID) $prID = $this->prID;;
        $where = "QID='".$prID."' AND UID='".$UID."' AND SUID='".$SUID."'";
        if ($KKOD) { $where .= " AND KKOD='".$KKOD."'"; }
        $ID = $this->getCell($this->idCell, $where);
        $this->ID = $ID;
        return $ID;
    }

    function getTableName($prID=0) {
        if (! $prID) $prID = $this->prID;
        if (! $prID) { $this->Error($this->className.": missing ID (".$prID.") to connect to project_users table!"); return false; }
        $tbl_name = str_replace("{ID}", $prID, $this->tbl_name_tmpl);
        return $tbl_name;
    }

    function setTable($prID=0) {
        if (! $prID) $prID = $this->prID;
        $this->table = $this->getTableName($prID);
        $this->set_tables = true;
    }

    function isOnline($ID=0) {
        $ID = $this->checkID($ID);
        if (! $ID) return false;
        else $this->ID = $ID;
        if (! $this->prID) return false;
        $this->getInfo();
        return (boolean) $this->Info['ONLINE'];
    }

    // ------------------ KUTATS FOLYAMATA ----------------------
    function checkSurveyUser($ID=0) {
        $ID = $this->checkID($ID);
        if (! $ID) return false;
        else $this->ID = $ID;
        if (! $this->prID) return false;
        $this->getInfo();
        $QID = $this->Info['QID'];
        if ($QID != $this->prID) return false;

        return true;
    }

    // A Kutats kezdete
    function loginSurvey($KKOD, $ID=0) {
        if (! $this->checkSurveyUser($ID)) return false;
        if (! $KKOD) return false;

        $saveArr = array( "CLIENTNUM" => _GEPSZAM,
            "KKOD" => $KKOD);
        if ($this->Info["KBEGIN"] == "0") {
            $saveArr["KBEGIN"] = 1;
            $saveArr["STARTDATE"] = "NOW()";
        }
        return $this->Save($saveArr);
    }

    // A Kutats eltti onine check eredmny trolsa
    function saveLoginOnlineCheck($isOnline, $ID=0) {
        if (! $this->checkSurveyUser($ID)) return false;

        $saveArr = array( "ONLINE" => $isOnline);
        return $this->Save($saveArr);
    }

    // A krdv kezdete
    function startSurvey($lsID, $ID=0) {
        global $dbConnLS;
        if (! $this->checkSurveyUser($ID)) return false;
        if (! $lsID) return false;
        $uInfo = $this->getInfo();

        $token_table = "lime_tokens_".$lsID;
        $oLSDB = new Basic($dbConnLS);
        $oLSDB->table = $token_table;
        $oLSDB->idCell = "tid";
        $tokenID = $oLSDB->getCell($oLSDB->idCell, "token='".$this->Info['UID']."'");

        $saveArr = array(
            "firstname" => '1' ,
            "lastname" => '1' ,
            "email" => 'a@a.hu' ,
            "emailstatus" => 'OK' ,
            "language" => 'hu' ,
            "sent" => 'N' ,
            "remindersent" => 'N' ,
            "remindercount" => '0' ,
            "completed" => 'N',
            "usesleft" => '99',
            "attribute_1" => $uInfo['QID'],
            "attribute_2" => $uInfo['KKOD'],
            "attribute_3" => $uInfo['SUID'],
            "attribute_4" => $lsID,
            "attribute_5" => $uInfo['CLIENTNUM'],
            "attribute_6" => $this->ID,
            "attribute_7" => '',
            "attribute_8" => '',
            "attribute_9" => '',
            "attribute_10" => ''
        );
        if (! $tokenID) { // INSERT
            $saveArr["token"] = $this->Info['UID'];
            if ($oLSDB->Insert($saveArr)) { $tokenID = $oLSDB->ID; }
        } else { // UPDATE
            $oLSDB->Save($saveArr, $tokenID);
        }

        if (! $tokenID) return $this->Error("Nem sikerlt beszrni sort a token tblba: ".$oLSDB->table);

        $attrCells = array();
        for ($t=11; $t<=80; $t++) { $attrCells[] = "attribute_".$t; }
        $attrSaveArr = array();
        foreach ($attrCells as $cell) {
            $attrSaveArr[$cell] = $uInfo[strtoupper($cell)];
        }
        return $oLSDB->Save($attrSaveArr, $tokenID);
    }

    // A krdv vge
    function endSurvey($lsID, $postArr, $ID=0) {
        global $dbConnLS;
        if (! $this->checkSurveyUser($ID)) return false;
        if (! $lsID) return false;
        $uInfo = $this->getInfo();

        $token_table = "lime_tokens_".$lsID;
        $oLSDB = new Basic($dbConnLS);
        $oLSDB->table = $token_table;
        $oLSDB->idCell = "tid";
        $tokenID = $oLSDB->getCell($oLSDB->idCell, "token='".$this->Info['UID']."'");

        if (! $tokenID) return $this->Error("Nincs ilyen sor (tid: ".$tokenID.") a token tblban: ".$oLSDB->table);

        $tokenInfo = $oLSDB->getInfo($tokenID);
        $attrCells = array();
        for ($t=7; $t<=80; $t++) { $attrCells[] = "attribute_".$t; }
        $attrSaveArr = array("FBLOCK" => $uInfo['FBLOCK']+1 );
        foreach ($attrCells as $cell) {
            $cellValue = Encoding::fixUTF8( Encoding::toUTF8( urldecode( $postArr[$cell]) ) );
            if ($cellValue) { $attrSaveArr[ strtoupper($cell) ] = $cellValue; }
        }
        return $this->Save($attrSaveArr);
    }

    // A kutats vge
    function logoutSurvey($ID=0) {
        if (! $this->checkSurveyUser($ID)) return false;

        $saveArr = array( 'KREADY' => 1,
            "ENDDATE" => "NOW()");

        return $this->Save($saveArr);
    }



    // ------------------ ADATSZINKRON FOLYAMATA ----------------------
    function saveTableForSync($save_file_dir) {
        if (! $this->table) return $this->Error("saveTableForSync() :: Nincs tblanv megadva");
        if (! $save_file_dir ) return $this->Error("saveTableForSync() :: Nincs megadva a mentsi knyvtr neve");

        $csvFile = $this->table."_filled".".csv";
        $csvFileUrl = $save_file_dir ."/". $csvFile;
        $csvContent = "";

        $sqlFile = $this->table."_filled".".sql";
        $sqlFileUrl = $save_file_dir ."/". $sqlFile;
        $sqlContent = "";
        $sqlInsertTable = $this->table . "_filled";
        $sqlWhere = "KBEGIN='1'";
        $sqlUniqueKeys = array("QID", "UID", "SUID", "CLIENTNUM");

        $sql_num_lines = $this->getCount();
        if ($sql_num_lines > 0) {
            $this->DBcon->SetFetchMode(ADODB_FETCH_ASSOC);
            $sqlRes = $this->sqlExe('SELECT * FROM '.$this->table." LIMIT 0,1");
            foreach ($sqlRes->fields as $fieldName=>$fieldData) {
                if ($fieldName != "id") {
                    $csvContent .= $fieldName . ";";
                    $sqlInsertFields .= "`" . $fieldName . "`,";
                }
            }
            $csvContent = substr($csvContent, 0, -1);
            $csvContent .= "\n";
            $sqlInsertFields = substr($sqlInsertFields, 0, -1);

            $dataRows = $this->getList($sqlWhere);
            foreach ($dataRows as $dID=>$dInfo) {
                $sqlInsertDatas = "";
                $sqlUpdateText = "";
                foreach ($dInfo as $cellName=>$cellValue) {
                    if ($cellName != "id") {
                        $csvContent .= $cellValue.";";
                        $sqlInsertDatas .= "'".$cellValue."',";
                        if (! in_array($cellName, $sqlUniqueKeys) ) { $sqlUpdateText .= "`".$cellName."`='".$cellValue."',"; }
                    }
                }
                $csvContent = substr($csvContent, 0, -1);
                $csvContent .= "\n";
                $sqlInsertDatas = substr($sqlInsertDatas, 0, -1);
                $sqlUpdateText = substr($sqlUpdateText, 0, -1);
                $sqlRow = "INSERT INTO `".$sqlInsertTable."` (".$sqlInsertFields.") VALUES(".$sqlInsertDatas.") ON DUPLICATE KEY UPDATE ".$sqlUpdateText.";";
                $sqlContent .= $sqlRow."\n";
            }
        }

        // CSV file save
        $fileHandler = fopen($csvFileUrl, 'w+');
        if ($sql_num_lines) {
            if (fwrite($fileHandler, $csvContent) === false) return $this->Error("Nem rhat ez a fjl: " . $csvFileUrl);
        }
        fclose($fileHandler);

        // SQL file save
        $fileHandler = fopen($sqlFileUrl, 'w+');
        if ($sql_num_lines) {
            if (fwrite($fileHandler, $sqlContent) === false) return $this->Error("Nem rhat ez a fjl: " . $sqlFileUrl);
        }
        fclose($fileHandler);

        return $sqlFile;
    }


    // ----------- Cmlista sor msolsa msik Projekthez ------------------
    function copyUserToProject($copyPrID) {
        global $dbConn;
        if (! $copyPrID) return false;
        if (! $this->checkID()) return false;
        $userInfo = $this->getInfo();

        $oCopyProject = new swProjectClient($dbConn);
        $oCopyProject->ID = $copyPrID;
        $oCopyProject->setUserTables();
        $copyDbSturcture = $oCopyProject->getColumnNames();

        if (! $oCopyProject->oUsers->getCount("UID='".$userInfo['UID']."'")) {
            $saveCellArr = array("UID", "PLACENAME", "PLACE", "COUNTYNAME", "COUNTY", "AGE", "GENDER", "EDUC",
                "INSTRUKTORNAME", "INSTRUKTOR", "LESKEY");
            for ($a=11; $a<=80; $a++) { $saveCellArr[] = "ATTRIBUTE_".$a; }
            $saveArr = array("QID" => $copyPrID);
            foreach ($saveCellArr as $cell) {
                $saveArr[$cell] = $userInfo[$cell];
            }
            return $oCopyProject->oUsers->Insert($saveArr);
        } else return false;
    }


} // END class

