<?php
$listaURL = $mainURL."&op=project_list";
$ajaxUrl = _SERVER_AJAX_URL ."&cmd=get_active_projects";

if (! IS_INTERNET) {
    header('Location: '.$listaURL);
    exit();
}


include(ARCULAT_DIR."/header.php");

echo aui_title("Frissítések telepítése");
?>



<script>
    var successProjectCount = 0;
    var checkedProjectCount = 0;
    var allProjectCount = 0;

    $(document).ready(function(){
        getProjectList();
    });

    function getProjectList() {
        var ajaxUrl = "<?php echo _SERVER_AJAX_URL ?>&cmd=get_active_projects";
        $.ajax({
            url: ajaxUrl,
            dataType: 'jsonp',
            type: "GET",
            success: function( data ) {
                if( 'error' in data ){
                    alert( "ERROR:  " + data.error);
                } else {
                    if (data !== null) {
                        updateProjectTables(data);
                    } else {
                        $('#showdata').html("<p>A visszatérő érték NULL!</p>");
                    }
                }
            },
            error: function( xhr, status, error ) { 
                alert( "ERROR:  " + xhr.responseText + " - " + status + " - " + error  );
            }
        });
    }

    function updateProjectTables(prList) {
        $.each( prList, function( key, value ) {
            allProjectCount++;
            addNewUpdateRow( key, value.name+' (ID:'+key+")" );
        });

        if (allProjectCount > 0) {
            $.each( prList, function( key, value ) {

                var prData = JSON.stringify(value);
                var ajaxUrl = "<?php echo _AJAX_URL; ?>";
                $.ajax({
                    url: ajaxUrl,
                    dataType: 'jsonp',
                    type: "POST",
                    data: { prData: prData,
                            prid: key,
                            cmd:'updateProject'},
                    success: function( data ) {
                        if (data !== null) {
                            if (data.status == "success") { successProjectCount++; }
                            changeRowStatus(data.prid, data.msg, data.status);
                        } else {
                            $('#showdata').append("<p>updateProjectTables - Hiba lépett fel.!</p>");
                        }
                        checkedProjectCount++;
                    },
                    error: function( xhr, ajaxOption, thrownError ) {
                        alert( this.url + " ERROR:  " + xhr.responseText + "\n thrownError");
                        changeRowStatus(data.prid, data.msg, "danger");
                        checkedProjectCount++;
                    }
                });

            });
        }
        else { checkEndOfRefresh(); }
    }

    function updateLimeSystemSQL() {
        var ajaxUrl = "<?php echo _AJAX_URL; ?>";
        $.ajax({
            url: ajaxUrl,
            dataType: 'jsonp',
            type: "POST",
            data: { cmd:'updateLimeSystemSQL' },
            success: function( data ) {
                if (data.status == "success") {
                    // $('#succes_update_msg').append("A LimeSurvey SQL frissítés rendben lefutott!");
                    $('#succes_update_msg').append("A kérdőív(ek) frissítése rendben lefutott!!");

                } else {
                    $('#succes_update_msg').append("ERROR !!! Hiba lépett fel LimeSurvey SQL tábla frissítésekor!");
                }
                endSuccess();
            },
            error: function( xhr, ajaxOption, thrownError ) {
                alert( this.url + " ERROR:  " + xhr.responseText + "\n thrownError");
                $('#succes_update_count').append("<p>ERROR !!! Hiba lépett fel LimeSurvey SQL tábla frissítésekor!</p>");
                endSuccess();
            }
        });
    }

    function updateKerdezoSQL() {
        var ajaxUrl = "<?php echo _AJAX_URL; ?>";
        $.ajax({
            url: ajaxUrl,
            dataType: 'jsonp',
            type: "POST",
            data: { cmd:'updateKerdezoSQL' },
            success: function( data ) {
                if (data.status == "success") {
                    // $('#succes_update_msg').append("A Kérdezőkód tábla frissítése rendben lefutott!<br>");
                } else {
                    $('#succes_update_msg').append("ERROR !!! Hiba lépett fel Kérdezőkód tábla frissítésekor!<br>");
                }
            },
            error: function( xhr, ajaxOption, thrownError ) {
                alert( this.url + " ERROR:  " + xhr.responseText + "\n thrownError");
                $('#succes_update_count').append("<p>ERROR !!! Hiba lépett fel Kérdezőkód tábla frissítésekor!</p>");
            }
        });
    }

    function addNewUpdateRow(id, pr_name) {
        $("#td_project_sample .name").html(pr_name);
        var new_row = $("#td_project_sample").html();
        new_row = new_row.replace('{ID}', id);
        $('#showdata').append( new_row );
    }

    function changeRowStatus(id, msg, status) {
        var objID = "#td_project_" + id;
        $(objID+" .status").html(msg);
        if (status) {
            var def_class = "bg-secondary";
            var new_class = "bg-"+status;
            $(objID).removeClass( def_class );
            $(objID).addClass( new_class );
            if (! (status == 'success' || status == 'danger')) {
                $(objID).hide(500);
            }
        }
        checkEndOfRefresh();
    }

    function checkEndOfRefresh() {
        if ( (checkedProjectCount + 1) == allProjectCount) {
            updateKerdezoSQL();
            if (successProjectCount > 0) {
                updateLimeSystemSQL();
            }
            else {
                endSuccess();
            }
        }
    }
    
    function endSuccess() {
        $('#succes_update_count').html(successProjectCount);
        $('#end_process_div').show(1000);
    }
</script>


<div id="end_process_div" style="display: none;">
    <h5 class="text-primary">
        Frissített kérdőívek száma: <span id="succes_update_count">-</span>
        <div id="succes_update_msg"></div>
    </h5>
    <?php echo aui_backButton($listaURL, "Tovább a kérdőívek listájához"); ?>
</div>

<div id="showdata" class="mt-3"></div>


<div id="td_project_sample" style="display: none;">
    <div id="td_project_{ID}" class="project_card card bg-secondary text-white shadow p-3">
        <span class="name"></span>
        <span class="status">
            <?php echo aui_spinnerDiv(); ?>
        </span>
    </div>
</div>



<?php
include(ARCULAT_DIR."/footer.php");
?>