<?php
switch ($_REQUEST["cmd"]) {

    // ################ UPDATE PROJECT SQL + DATAS #################
    case "updateProject":
        $dataArr['status'] = "secondary"; // "", "success", "warning", "danger"
        $dataArr{"msg"} = "A kérdőívhez nincs elérhető frissítés. ";
        $dataArr{"details"} = "";

        $prID = $_REQUEST["prid"];
        $dataArr["prid"] = $prID;
        $install_package = false;


        if (! $prID) { $error = "updateProject(): Nincs project ID!"; break; }
        $oProject->ID = $prID;
        $newPrInfo = json_decode($_REQUEST["prData"], true);


        // -------------- Ha nem létezik (ÚJ adatbázis rekord) --------------------
        if (! $oProject->exists()) {
            $testArr = explode(',', $newPrInfo['test_machines']);
            // Csak akkor telepíti, ha TESZT vagy AKTIV állapotú a kutatás
            if ( ($newPrInfo['status'] == RES_TEST && in_array(_GEPSZAM, $testArr) ) || $newPrInfo['status'] == RES_ACTIVE ) {
                $saveArr = array(
                    "id" => $newPrInfo['id'],
                    "start_time" => "NOW()",
                    "name" => $newPrInfo['name'],
                    "ls_blocks" => $newPrInfo['ls_blocks'],
                    "status" => $newPrInfo['status'],
                    "use_SUID" => $newPrInfo['use_SUID'],
                    "sound" => $newPrInfo['sound'],
                    "hide_for_client" => $newPrInfo['hide_for_client']
                );
                if ($oProject->Insert($saveArr)) {
                    $new = true;
                    $install_package = true;
                    $dataArr["msg"] = "Új kérdőív telepítve. || Státus: ".$modConf['statusArr'][ $newPrInfo['status'] ];
                    $dataArr['status'] = "success";
                }
            } else {
                $dataArr['status'] = "warning";
                $dataArr{"msg"} = "Nem lehet még telepíteni ";
            }
        }
        // --------------- Ha már létező kutatás ---------------------
        else {
            $oldPrInfo = $oProject->getInfo();
            if ($oldPrInfo['install_pack_version'] < $newPrInfo['install_pack_version']) {
                $install_package = true;
            }
            $saveArr = array(
                "id" => $newPrInfo['id'],
                "start_time" => "NOW()",
                "name" => $newPrInfo['name'], 
                "ls_blocks" => $newPrInfo['ls_blocks'],
                "status" => $newPrInfo['status'],
                "use_SUID" => $newPrInfo['use_SUID'],
                "sound" => $newPrInfo['sound'],
                "hide_for_client" => $newPrInfo['hide_for_client']
            );
            if ($oProject->Save($saveArr)) {
                if ( $newPrInfo['status'] == RES_CLOSED && $oldPrInfo['status'] == RES_ACTIVE ) {
                    if ( $oProject->syncFiles($prID) ) {
                        $dataArr['status'] = "warning";
                        $dataArr{"msg"} = "A kérdőív le lett zárva. A továbbiakban ez a kérdőív már nem lesz elérhető ezen az eszközön.";
                    }
                    else { $error = ("Hiba történt a ".$newPrInfo['name']." kérdőív adatainak szonkronizálása közben."); }
                }
                // ------- Ha törlésre került a kutatás -----------------
                else if ($newPrInfo['status'] == RES_DELETED && $oldPrInfo['status'] != RES_DELETED) {
                    $oProject->deleteProject();
                    $dataArr['status'] = "danger";
                    $dataArr{"msg"} = "A kérdőív törölve lett a rendszerből.";
                }
            } else { $error = ("Hiba történt a ".$newPrInfo['name']." kérdőív adatainak frissítésekor."); }
        }
        
        // ----------- Ha le kell tölteni és installálni kell kutatáshoz telepítőcsomagot -----------------------
        if ($install_package) {
            $resInst = $oProject->installPackage($newPrInfo['install_pack_version']);
            $dataArr["details"] = $resInst;
            $dataArr['status'] = "success";
            $dataArr{"msg"} = "A kérdőívhez az új frissítések telepítése rendben megtörtént.";
        }
        break;


    // ################ UPDATE LIMESURVEY SYSTEM SQL #################
    case "updateLimeSystemSQL":
        $dataArr['status'] = "success";
        if ($resInst = $oProject->installLimeSystemSQL()) {
            $dataArr["prid"] = "lsdb";
            $dataArr["details"] = $resInst;
            $dataArr['status'] = "success";
            $dataArr{"msg"} = "A LimeSurvey rendszertáblái frissítve lettek.";
        }
        break;

    // ################ UPDATE KÉRDEZŐKÖD SQL #################
    case "updateKerdezoSQL":
        $dataArr['status'] = "success";
        if ($resInst = $oProject->installKerdezoSQL()) {
            $dataArr["prid"] = "kkoddb";
            $dataArr["details"] = $resInst;
            $dataArr['status'] = "success";
            $dataArr{"msg"} = "A kérdezőkód tábla frissítve lett.";
        }
        break;

    default:
        break;
}


header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Origin, Content-Type, Accept,Authorization, X-Request-With');
header('Access-Control-Allow-Credentials: true');

if ($error) {
    $dataArr['response'] = false;
    $dataArr['status'] = "danger";
    $dataArr['msg'] = $error;
    echo $_GET['callback'] . '('.json_encode($dataArr).')';
} else {
    echo $_GET['callback'] . '('.json_encode($dataArr).')';
}

?>