<?php
$listaURL = $mainURL."&op=project_list";

if (! IS_INTERNET) {
    header('Location: '.$listaURL);
    exit();
}

$oProject->checkHideForClientCell();


include(ARCULAT_DIR."/header.php");

echo aui_title("Frissítések telepítése");




// --------- A projektek listájának lekérdezése a szerverről ---------
$url = _SERVER_AJAX_URL ."&cmd=get_active_projects";
$url .= "&calltype=php";
$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, $url);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
curl_setopt($curl, CURLOPT_HEADER, false);
$result = curl_exec($curl);
curl_close($curl);
$projectList = json_decode($result, true);



// --------- Letöltött projektlista ellenőrzése, hogy kell-e frissítést végrehajtani ---------
$updateProjectArr = array(); // A frissítendő kutatások ID-jei és típusa ==> $updateProjectArr[PROJECT_ID] = install | reinstall | update | close | delete
$htmlRows = "";

if (is_array($projectList)) {
    foreach ($projectList as $prID=>$newPrInfo) {
        $oProject->ID = $prID;
        $projectTitle = $newPrInfo['name']."(".$prID.")";
        // Ha a kutatás még nincs letöltve erre a gépre
        if (! $oProject->exists()) {
            $testArr = explode(',', $newPrInfo['test_machines']);
            // Csak akkor telepíti, ha TESZT vagy AKTIV állapotú a kutatás
            if ( ($newPrInfo['status'] == RES_TEST && in_array(_GEPSZAM, $testArr) ) || $newPrInfo['status'] == RES_ACTIVE ) {
                $updateProjectArr[$prID] = "install";
                $htmlRows .= newUpdateRow($prID, $projectTitle, "Új kutatás telepítése...");
            }
        }
        // Ha a kutatás már létezik
        else {
            $oldPrInfo = $oProject->getInfo();
            // Ha lezárult a kutatás
            if ( $newPrInfo['status'] == RES_CLOSED && $oldPrInfo['status'] == RES_ACTIVE ) {
                $updateProjectArr[$prID] = "close";
                $htmlRows .= newUpdateRow($prID, $projectTitle, "Kutatás lezárása...");
            }
            // Ha van új install csomag a kutatáshoz
            else if ($oldPrInfo['install_pack_version'] < $newPrInfo['install_pack_version']) {
                $updateProjectArr[$prID] = "reinstall";
                $htmlRows .= newUpdateRow($prID, $projectTitle, "Kutatás frissítése...");
            }
            // Ha a kutatást törölték az utolsó frissítés óta
            else if ($newPrInfo['status'] == RES_DELETED) {
                if ($oldPrInfo['status'] != RES_DELETED) {
                        $updateProjectArr[$prID] = "delete";
                        $htmlRows .= newUpdateRow($prID, $projectTitle, "Kutatás törlése...");
                }
            }
            // Ha csak a kutatás adatait kell frissíteni
            else {
                $updateProjectArr[$prID] = "update";
                $htmlRows .= newUpdateRow($prID, $projectTitle, "");
            }
        }
    }

    $allProjectCount = 0; // Frissítendő kutatások száma
    $updateLSdb = 0; // Kell-e az LimeSurvey adatbázist frissíteni?
    $jsProjectArray = "0"; // A javascriptnek átadandó frissíteni való kutatás ID-k tömb
    foreach ($updateProjectArr as $prID=>$prToDo) {
        $allProjectCount++;
        $jsProjectArray .= ",".$prID;
        if ($prToDo == "install" || $prToDo == "reinstall") { $updateLSdb = 1; }
    }
    if ($updateLSdb) {
        $allProjectCount++;
        $htmlRows = newUpdateRow("lsdb", "LimeSurvey adatbázis frissítése...", "") . $htmlRows;
    }

    if ($allProjectCount) {
        $allProjectCount++;
        $htmlRows .= newUpdateRow("kkoddb", "Kérdezőkód lista frissítése...", "");
    }

}

// --------- Ha nincs semmilyen project ---------
else {
    $htmlRows = "<h4>Nincs hozzáférhető kutatás a szerveren!</h4>";
}



// ------------------------ UPDATE ROW SAMPLE ------------------------------
function newUpdateRow($prID, $title, $msg) {
    $html = '<div id="td_project_sample">
        <div id="td_project_'.$prID.'" class="project_card card bg-secondary text-white shadow p-3">
            <span class="name">'.$title.'</span>
            <span class="msg">'.$msg.'</span>
            <span class="status">'.aui_spinnerDiv() .'</span>
        </div>
    </div>';
    return $html;
}
?>



    <script>
        var updateLSdb = <?php echo $updateLSdb; ?>; // Kell-e frissíteni az LS adatbázist
        var allProjectCount = <?php echo $allProjectCount; ?>; // Frissítendő kutatások száma
        var updateProjectArray = [ <?php echo $jsProjectArray; ?> ]; // Frissítendő kutatások ID-i

        var successProjectCount = 0;
        var checkedProjectCount = 0;

        $(document).ready(function() {
            if (allProjectCount > 0) {
                if (updateLSdb) { updateLimeSystemSQL(); }
                else { getProjectList(); }
                updateKerdezoSQL();
            }
            else { checkEndOfRefresh(); }
        });

        function updateLimeSystemSQL() {
            var ajaxUrl = "<?php echo _AJAX_URL; ?>";
            $.ajax({
                url: ajaxUrl,
                dataType: 'jsonp',
                type: "POST",
                data: {cmd: 'updateLimeSystemSQL'},
                success: function (data) {
                    if (data.status == "success") {
                        changeRowStatus(data.prid, data.msg, data.status);
                        checkEndOfRefresh();
                        getProjectList();
                    } else {
                        $('#succes_update_msg').append("ERROR !!! Hiba lépett fel LimeSurvey SQL tábla frissítésekor!");
                    }
                },
                error: function (xhr, ajaxOption, thrownError) {
                    alert(this.url + " ERROR:  " + xhr.responseText + "\n thrownError");
                    $('#succes_update_count').append("<p>ERROR !!! Hiba lépett fel LimeSurvey SQL tábla frissítésekor!</p>");
                }
            });
        }

        function getProjectList() {
            var ajaxUrl = "<?php echo _SERVER_AJAX_URL ?>&cmd=get_active_projects";
            $.ajax({
                url: ajaxUrl,
                dataType: 'jsonp',
                type: "GET",
                success: function( data ) {
                    if( 'error' in data ){
                        alert( "ERROR:  " + data.error);
                    } else {
                        if (data !== null) {
                            updateProjectTables(data);
                        } else {
                            $('#showdata').html("<p>A visszatérő érték NULL!</p>");
                        }
                    }
                },
                error: function( xhr, status, error ) {
                    alert( "ERROR:  " + xhr.responseText + " - " + status + " - " + error  );
                }
            });
        }

        function updateProjectTables(prList) {
            $.each( prList, function( key, value ) {
                var keyID = parseInt(key, 10);
                if ( updateProjectArray.includes(keyID, 1) ) {
                    var prData = JSON.stringify(value);
                    var ajaxUrl = "<?php echo _AJAX_URL; ?>";
                    $.ajax({
                        url: ajaxUrl,
                        dataType: 'jsonp',
                        type: "POST",
                        data: { prData: prData,
                            prid: key,
                            cmd:'updateProject'},
                        success: function( data ) {
                            if (data !== null) {
                                if (data.status == "success") { successProjectCount++; }
                                changeRowStatus(data.prid, data.msg, data.status);
                                checkEndOfRefresh();
                            } else {
                                $('#showdata').append("<p>updateProjectTables - Hiba lépett fel.!</p>");
                            }
                        },
                        error: function( xhr, ajaxOption, thrownError ) {
                            alert( this.url + " ERROR:  " + xhr.responseText + "\n thrownError");
                            changeRowStatus(data.prid, data.msg, "danger");
                        }
                    });
                }
            });
        }

        function updateKerdezoSQL() {
            var ajaxUrl = "<?php echo _AJAX_URL; ?>";
            $.ajax({
                url: ajaxUrl,
                dataType: 'jsonp',
                type: "POST",
                data: { cmd:'updateKerdezoSQL' },
                success: function( data ) {
                    if (data.status == "success") {
                        changeRowStatus(data.prid, data.msg, data.status);
                        checkEndOfRefresh();
                    } else {
                        $('#succes_update_msg').append("ERROR !!! Hiba lépett fel Kérdezőkód tábla frissítésekor!<br>");
                    }
                },
                error: function( xhr, ajaxOption, thrownError ) {
                    alert( this.url + " ERROR:  " + xhr.responseText + "\n thrownError");
                    $('#succes_update_count').append("<p>ERROR !!! Hiba lépett fel Kérdezőkód tábla frissítésekor!</p>");
                }
            });
        }

        function changeRowStatus(id, msg, status) {
            var objID = "#td_project_" + id;
            $(objID+" .status").html(msg);
            if (status) {
                var def_class = "bg-secondary";
                var new_class = "bg-"+status;
                $(objID).removeClass( def_class );
                $(objID).addClass( new_class );
                if (! (status == 'success' || status == 'warning')) { // status == 'danger' ||
                    $(objID).hide(500);
                }
            }
        }

        function checkEndOfRefresh() {
            checkedProjectCount++;
            if ( checkedProjectCount == allProjectCount ) {
                endSuccess();
            }
        }

        function endSuccess() {
            $('#succes_update_count').html(successProjectCount);
            $('#end_process_div').show(1000);
        }
    </script>




    <div id="end_process_div" style="display: none;">
        <h5 class="text-primary">
            Frissített kérdőívek száma: <span id="succes_update_count">-</span>
            <div id="succes_update_msg"></div>
        </h5>
        <?php echo aui_backButton($listaURL, "Tovább a kérdőívek listájához"); ?>
    </div>

    <div id="showdata" class="mt-3">
        <?php echo $htmlRows; ?>
    </div>




<?php
include(ARCULAT_DIR."/footer.php");
?>