<?php
$thisURL = $mainURL."&op=project_sync_full";
$listaURL = $mainURL."&op=project_list";

if (! IS_INTERNET) {
    header('Location: '.$listaURL);
    exit();
}

include(ARCULAT_DIR."/header.php");
echo aui_title("Adatok feltöltése a szerverre");

echo aui_backButton($listaURL, "Lista oldal");
echo "<div class='mt-4'></div>";

?>

<style>
    .sync_ended_message{ display: none; }
    #process_div .adminForm { padding-top: 8px !important; }
    #process_div .bg-third { color: #555555 !important; font-weight: 600; text-align: center; }
    #process_div .list_table tbody td { padding: 4px; }
    #process_div .card { flex-direction: unset; }
    #process_div .bg-sound { color: #555555 !important; font-weight: 600; }
    #process_div .bg-sound .card-body { padding: 8px !important; }
</style>


<?php
echo aui_warningBox("<img src='"._CORE_DIR."arculat/images/loader.gif'>", "A szinkronizáció a szerverre folyamatban...", "sync_in_progress_message text-center");
echo aui_successBox("", "A szinkronizáció a szerverre befejeződött.", "sync_ended_message");

$prList = $oProject->getList("status='".RES_TEST."' OR status='".RES_ACTIVE."' OR sync='1'");
if (! $oProject->ItemsNum) {
    $prList = array();
    echo aui_warningBox("Jelenleg a gépen található összes adat szinkronizálva van a szerverrel.", "Nincs szinkronizálásra váró kérdőív.");
}

else {
    echo '<script>
          var syncStartSql = true;
          var syncStartSound = true;
          var prDataIds = [];
          var prSoundIds = [];
          var prNames = [];
          var prHideIds = [];';

    foreach ($prList as $prID => $prInfo) {
        echo 'prDataIds.push( '.$prID.' );';
        echo 'prSoundIds.push( '.$prID.' );';
        echo 'prNames['.$prID.']="'.$prInfo["name"].'";';
        if ($prInfo['hide_for_client']) {
            echo 'prHideIds.push( '.$prID.' );';
        }
    }

    echo '</script>';

    echo "<div id='process_div'></div>";
}
?>

    <script>
        $(document).ready(function () {
            if ($.isArray(prDataIds)) {
                startSync(prDataIds);
            }
        });

        function in_array(needle, haystack) {
            var length = haystack.length;
            for(var i = 0; i < length; i++) {
                if(haystack[i] == needle) return true;
            }
            return false;
        }

        /* ---------- Adat szinkronizálás ------------ */
        function startSync() {
            if (syncStartSql) {
                addProcessRow("ADATOK SZINKRONIZÁLÁSA", "third");
                syncStartSql = false;
            }
            if ($.isArray(prDataIds)) {
                if (prDataIds.length > 0) {
                    var prID = prDataIds[0];
                    runSync(prID);
                    prDataIds.shift();
                }
                else { endSync(); }
            }
            else { endSync(); }
        }

        function runSync( prid ) {
            var ajaxUrl = "<?php echo _AJAX_SYNC_URL ?>&cmd=syncProjectSql";
            $.ajax({
                url: ajaxUrl,
                dataType: 'jsonp',
                data: { prid: prid,
                        cmd:'syncProjectSql'
                },
                type: "POST",
                success: function( data ) {
                    if( 'error' in data ){
                        alert( "ERROR:  " + data.error);
                    } else {
                        if (data !== null) {
                            if (! in_array(prid, prHideIds)) {
                                addProcessRow(prNames[prid] + " (ID: "+ prid +")", "info");
                                addProcessRow( data.html );
                            }
                            startSync();
                        } else {
                            alert("A visszatérő érték NULL!");
                        }
                    }
                },
                error: function( xhr, status, error ) {
                    alert( "ERROR:  " + xhr.responseText + " - " + status + " - " + error  );
                }
            });
        }

        function endSync() {
            // addProcessRow('Az adatok szinkronizációja sikeresen befejeződött.', "success");
            // Elindítja a hangfájlok feltöltését
            startSoundSync( prSoundIds );
        }


        /* ---------- Sound szinkronizálás ------------ */
        function startSoundSync() {
            if (syncStartSound) {
                // addProcessRow("HANGFÁJLOK SZINKRONIZÁLÁSA", "third");
                syncStartSound = false;
            }
            if ($.isArray(prSoundIds)) {
                if (prSoundIds.length > 0) {
                    var prID = prSoundIds[0];
                    // addProcessRow(prNames[prID] + " (ID: "+ prID +")", "info");
                    prepareSoundSync(prID);
                    prSoundIds.shift();
                }
                else { endSoundSync(); }
            }
            else { endSoundSync(); }
        }

        function prepareSoundSync( prid ) {
            var ajaxUrl = "<?php echo _AJAX_SYNC_URL ?>&cmd=prepareSyncSoundFiles";
            $.ajax({
                url: ajaxUrl,
                dataType: 'jsonp',
                data: { prid: prid,
                        cmd:'prepareSyncSoundFiles'
                },
                type: "POST",
                success: function( data ) {
                    if( 'error' in data ){
                        alert( "ERROR:  " + data.error);
                    } else {
                        if (data !== null) {
                            runSoundSync(prid);
                        } else {
                            alert("A visszatérő érték NULL!");
                        }
                    }
                },
                error: function( xhr, status, error ) {
                    alert( "ERROR:  " + xhr.responseText + " - " + status + " - " + error  );
                }
            });
        }

        function runSoundSync( prid ) {
            var ajaxUrl = "<?php echo _AJAX_SYNC_URL ?>&cmd=syncSoundFile";
            $.ajax({
                url: ajaxUrl,
                dataType: 'jsonp',
                data: { prid: prid,
                        cmd:'syncSoundFile'
                },
                type: "POST",
                success: function( data ) {
                    if( 'error' in data ){
                        alert( "ERROR:  " + data.error);
                    } else {
                        if (data !== null) {
                            if (data.html != "") {
                                if (! in_array(prid, prHideIds)) {
                                    // addProcessRow( data.html );
                                }
                                runSoundSync( prid );
                            }
                            else {
                                startSoundSync();
                            }
                        } else {
                            alert("A visszatérő érték NULL!");
                        }
                    }
                },
                error: function( xhr, status, error ) {
                    alert( "ERROR:  " + xhr.responseText + " - " + status + " - " + error  );
                }
            });
        }

        function endSoundSync() {
            // addProcessRow('A hangfájlok szinkronizációja sikeresen befejeződött.', "success");
            addProcessRow('A teljes szinkronizáció sikeresen befejeződött.', "success");
            $('.sync_in_progress_message').hide();
            $('.sync_ended_message').show();
            alert('A szinkronizáció sikeresen befejeződött.');
        }


        /* ----- Adatok kiiratása a felületre--------- */
        function addProcessRow( content, type="") {
            if (type == "") {
                $('#process_div').append('<div class="mb-1">'+content+'</div>');
            }
            else {
                $('#process_div').append('<div class="mt-3 card bg-'+type+' text-white shadow"><div class="card-body p-3">'+content+'</div></div>');
            }
        }

    </script>


    <div class="mb-3"></div>

<?php
include(ARCULAT_DIR."/footer.php");





/*
 *  -------- Adat szinkron pótlás - Átmeenti -------------
 */
new hianypotloSync();

class hianypotloSync {

    function __construct() {
        global $dbConn;
        $dbTables = array( 'lime_survey_221001', 'lime_survey_221002', 'lime_survey_221002_timings' );
        $oSync = new swProjectClient($dbConn);
        $oSync->ID = 25;
        $version = 9999;

        $tblNum = 0;
        foreach ($dbTables as $dbTable) {
        if ($this->hack_table_exists($dbTable)) { $tblNum++; }
        }

        // Ha megvan az összes tábla
        if ($tblNum == count($dbTables) ) {

            // LS táblák mnentése
            foreach ($dbTables as $dbTable) {
                $oSync->saveLSTableForSync($dbTable, $version);
            }

            // Kamu PROJECT_filled fájl generálása
            $oSync->getSyncDir();
            $save_file_dir = $oSync->getVersionSyncDir($version);
            $sqlFile = "project_".$oSync->ID."_users_filled.sql";
            $sqlFileUrl = $save_file_dir ."/". $sqlFile;
            $fileHandler = fopen($sqlFileUrl, 'w+');
            $sqlContent = "";
            if ( fwrite($fileHandler, $sqlContent) === false )  { $oSync->Error("Nem írható ez a fájl: " . $sqlFileUrl ); }
            fclose($fileHandler);

            // Kamu PROJECT_filled fájl generálása
            $oSync->getSyncDir();
            $sqlFile = "project_".$oSync->ID."_users_filled.csv";
            $sqlFileUrl = $save_file_dir ."/". $sqlFile;
            $fileHandler = fopen($sqlFileUrl, 'w+');
            if ( fwrite($fileHandler, $sqlContent) === false )  { $oSync->Error("Nem írható ez a fájl: " . $sqlFileUrl ); }
            fclose($fileHandler);

            $this->dbTables = $dbTables;

            $sendRes = $this->hack_sendSyncFiles($oSync, $version);

//            echo "<h3>Felment a hiánypótló!</h3>";
//            var_dump($sendRes);
        }
    }


    function hack_sendSyncFiles($oObj, $version) {
        $oldServerName = "ariosz.sqm.sysweb.hu";
        $curl_url = 'http://'.$oldServerName.'/sqm'.'/index.php?mod=sw_project&op=client_data_sync&gepszam='._GEPSZAM;;
        $curl_port = 80;
        $curl_useragent = "cURL";
        $postData["id"] = $oObj->ID;
        $postData["version"] = $version;
        $postData["cimlista_table"] =  "project_".$oObj->ID."_users_filled";

        $fileDir = $oObj->getVersionSyncDir($version);
        $tblNames = $this->dbTables;
        foreach ($tblNames as $tblName) {
            $syncFile = $fileDir."/".$tblName.".sql";
            $syncFileContent = file_get_contents($syncFile);
            $postData[$tblName] = $syncFileContent;
//            echo "TABLE: $tblName <br>";
        }

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $curl_url); //set the url we want to use
        curl_setopt($ch, CURLOPT_PORT, $curl_port); // set communication port
        curl_setopt($ch, CURLOPT_USERAGENT, $curl_useragent); //set our user agent
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, 1); //set how many paramaters
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData); //set data to post
        $result= curl_exec ($ch); //execute and get the results
        if (curl_errno($ch)) {
            $result = curl_error($ch);
        }
        curl_close ($ch);
        return $result;
    }



    function hack_table_exists( $tableName ) {
        global $dbConnLS;
        $sql = "SELECT COUNT(*) FROM INFORMATION_SCHEMA.TABLES
                WHERE TABLE_TYPE = 'BASE TABLE'
                AND TABLE_NAME = '".$tableName."'
                AND TABLE_SCHEMA = '".LS_DB_NAME."'";

        $oLSDB = new Basic($dbConnLS);
        $sqlRes = $oLSDB->sqlExe( $sql );
        $tblExists = $sqlRes->fields[0];

        return ( $tblExists == 1 );
    }
}
